From 9cf25c8048c56050594d39b9a37be60e2e37bb54 Mon Sep 17 00:00:00 2001
From: Vincent Petry <pvince81@owncloud.com>
Date: Thu, 3 Oct 2013 12:53:13 +0200
Subject: [PATCH] Added backup for config.php in autotest.sh script

The script now checks for config.php existance and backs it up before
running the test, then restores it back at the end. This avoids the
situation where devs lose their manually edited config if they forgot to
back it up before running the unit tests.

The script now also checks for config.php permissions beforehand to
avoid displaying an annoying HTML page output in the console with an
error message.
---
 autotest.sh | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

diff --git a/autotest.sh b/autotest.sh
index 83f184fa9c0..3831e181245 100755
--- a/autotest.sh
+++ b/autotest.sh
@@ -12,6 +12,16 @@ DATABASEUSER=oc_autotest$EXECUTOR_NUMBER
 ADMINLOGIN=admin$EXECUTOR_NUMBER
 BASEDIR=$PWD
 
+if ! [ -w config -a -w config/config.php ]; then
+	echo "Please enable write permissions on config and config/config.php" >&2
+	exit 1
+fi
+
+# Back up existing (dev) config if one exists
+if [ -f config/config.php ]; then
+	mv config/config.php config/config-autotest-backup.php
+fi
+
 # use tmpfs for datadir - should speedup unit test execution
 if [ -d /dev/shm ]; then
   DATADIR=/dev/shm/data-autotest$EXECUTOR_NUMBER
@@ -158,6 +168,13 @@ else
 	execute_tests $1 $2 $3
 fi
 
+cd $BASEDIR
+
+# Restore existing config
+if [ -f config/config-autotest-backup.php ]; then
+	mv config/config-autotest-backup.php config/config.php
+fi
+
 #
 # NOTES on mysql:
 #  - CREATE DATABASE oc_autotest;
-- 
GitLab